#ifndef _STUDENT_H
#define _STUDENT_H

#include <string>
#include <fstream>

using namespace std;

class Student
{
public: 
   unsigned int getIdNum() const {  return sIdNum;  }
   void clearCourses() {  sNoOfCourses = 0;  sWH = 0;  }
   unsigned int getWH() const {  return sWH;  }
   void add1Course( int aIncrWH );
   void readFromText( istream& tin );
   void save( ostream& bout ) const;
   void display( ostream& tout );
private:
   enum { sNameSz = 20,
          sSaveSz = sizeof(int) + 2*sNameSz + 2*sizeof(int) };
   unsigned int sIdNum;        //  
   char         sSurname[sNameSz];
   char         sFirstname[sNameSz];
   unsigned int sWH;           //   
   unsigned int sNoOfCourses;  //    

   unsigned int countTabs( string aLine );
}; // Student

typedef Student* PStudent;

struct StudentXptn
{
   enum { incomplete, negIdNum, nonPosIncr, fileNotOpen, cannotRead, cannotWrite };
   char methodName[100];
   int  errorCode;
   int  errIntVal;
   char errStrVal[100];
   StudentXptn( const char* mn, int ec, int ev )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';
      errorCode = ec;  errIntVal = ev;  }
   StudentXptn( const char* mn, int ec, const char* sv="" )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';
      errorCode = ec;
      strncpy( errStrVal, sv, 99 );  errStrVal[99] = '\0';  }
}; // StudentXptn

#endif // _STUDENT_H
